﻿Public Class GeneralizedMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim frm As New frmP("Enter value for power (p)...")
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        If frm.ShowDialog = DialogResult.OK Then
            Dim p As Integer = CInt(frm.NumericUpDown1.Value)
            If p > 1 Then
                Dim sum As Decimal
                For x As Integer = 0 To numbersAsInteger.GetUpperBound(0)
                    sum += CDec(Math.Pow(numbersAsInteger(x), p))
                Next
                Return Math.Pow((sum / numbersAsInteger.Count), 1 / p)
            End If
        End If
        Return 0
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Generalized mean"
    End Function

End Class
