﻿Public Class HarmonicMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Dim sum As Decimal
        For Each n As Integer In numbersAsInteger
            sum += CDec(n ^ -1)
        Next
        Return (sum / numbersAsInteger.Count) ^ -1
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Harmonic mean"
    End Function

End Class
