﻿Public Class QuadraticMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Dim sum As Decimal
        For Each n As Integer In numbersAsInteger
            sum += CDec(n ^ 2)
        Next
        Return Math.Sqrt(sum / numbersAsInteger.Count)
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Quadratic mean"
    End Function

End Class
