﻿Public Class WinsorizedMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Array.Sort(numbersAsInteger)
        Dim frm As New frmP("Enter # winsorized values...(per end)")
        If frm.ShowDialog = DialogResult.OK Then
            Dim i As Integer = CInt(frm.NumericUpDown1.Value)
            If i > 0 Then
                For x As Integer = 0 To i - 1
                    numbersAsInteger(x) = numbersAsInteger(i)
                    numbersAsInteger(numbersAsInteger.GetUpperBound(0) - x) = numbersAsInteger(numbersAsInteger.GetUpperBound(0) - i)
                Next
                Return numbersAsInteger.Average
            End If
        End If
        Return 0
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Winsorized mean"
    End Function

End Class
