﻿Public Class ArithmeticMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Return numbersAsInteger.Average
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Arithmetic mean"
    End Function

End Class
