﻿Public Class CubicMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Dim sum As Decimal
        For x As Integer = 0 To numbersAsInteger.GetUpperBound(0)
            sum += CDec(Math.Pow(numbersAsInteger(x), 3))
        Next
        Return Math.Pow((sum / numbersAsInteger.Count), 1 / 3)
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Cubic mean"
    End Function

End Class
