﻿Public Class Median
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Array.Sort(numbersAsInteger)
        If numbersAsInteger.Count Mod 2 = 1 Then
            Return numbersAsInteger(CInt(CInt(numbersAsInteger.Count - 1) / 2))
        Else
            Dim halfway(1) As Integer
            halfway(0) = numbersAsInteger(CInt(numbersAsInteger.Count / 2) - 1)
            halfway(1) = numbersAsInteger(CInt(numbersAsInteger.Count / 2))
            Return halfway.Average
        End If
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Median"
    End Function

End Class
