﻿Public Class Midrange
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Array.Sort(numbersAsInteger)
        Return (numbersAsInteger.First + numbersAsInteger.Last) / 2
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Midrange"
    End Function

End Class
