﻿Public Class TruncatedMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Array.Sort(numbersAsInteger)
        Dim frm As New frmP("Enter # truncated values...(per end)")
        If frm.ShowDialog = DialogResult.OK Then
            Dim i As Integer = CInt(frm.NumericUpDown1.Value)
            If i > 0 Then
                Return numbersAsInteger.Skip(i).Take(numbersAsInteger.Count - (i * 2)).Average
            End If
        End If
        Return 0
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Truncated mean"
    End Function

End Class
