﻿Public Class frmWeights
    Public Sub New(items() As Object)
        InitializeComponent()

        For Each i As Object In items
            If Not i.ToString.Contains("{") Then
                i = i.ToString & "   {1}"
            End If
            ListBox1.Items.Add(i)
        Next

        Me.KeyPreview = True
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        If ListBox1.SelectedIndex = -1 Then NumericUpDown2.Value = 0 : NumericUpDown2.Enabled = False : Return
        NumericUpDown2.Enabled = True
        Dim parts() As String = ListBox1.Items(ListBox1.SelectedIndex).ToString.Split(New String() {"   {", "}"}, StringSplitOptions.None)
        NumericUpDown2.Value = CDec(parts(1))
        Button2.Enabled = ListBox1.SelectedIndex > -1
    End Sub

    Private Sub NumericUpDown2_ValueChanged(sender As Object, e As EventArgs) Handles NumericUpDown2.ValueChanged
        If ListBox1.SelectedIndex = -1 Then Return
        Dim parts() As String = ListBox1.Items(ListBox1.SelectedIndex).ToString.Split(New String() {"   {", "}"}, StringSplitOptions.None)
        Dim w As Object = NumericUpDown2.Value
        If NumericUpDown2.Value Mod 1 = 0 Then
            w = CInt(NumericUpDown2.Value)
        End If
        ListBox1.Items(ListBox1.SelectedIndex) = parts(0) & "   {" & If(w.ToString.Contains("."), w.ToString.TrimEnd("0"c), w.ToString) & "}"
    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.Return Then Button1.PerformClick()
    End Sub

    Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles NumericUpDown1.ValueChanged
        Button1.Enabled = NumericUpDown1.Value > 0D
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        ListBox1.Items.RemoveAt(ListBox1.SelectedIndex)
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ListBox1.Items.Add(NumericUpDown1.Value & "   {1}")
    End Sub

End Class